from django.conf.urls import url
from trunk.views import competitions as tv
import branch.views.competitions as comp_views
from forms.views import manage_rubrics


urlpatterns = [

    url(r'^list$',
        tv.ManageCompetitions.as_view(), name='uni-manage-applications'),
    url(r'^create',
        tv.CreateCompetition.as_view(), name='uni-create-application'),
    url(r'^(?P<event_id>[^/]+)/edit$',
        tv.EditCompetition.as_view(), name='uni-edit-application'),
    url(r'^(?P<event_id>[^/]+)/questions$',
        tv.ManageQuestions.as_view(), name='uni-edit-application-question'),
    url(r'^(?P<event_id>[^/]+)/rubrics$',
        manage_rubrics, name='uni-edit-application-rubrics'),
    url(r'^(?P<event_id>[^/]+)/judges$',
        tv.CreateJudgeBoard.as_view(), name='uni-edit-application-judges'),
    url(r'^(?P<event_id>[^/]+)/(?P<board_id>[^/]+)/invite_judge/(?P<judge_id>[^/]+)$',
        comp_views.send_judge_invitations, name='send-single-app-judge-invite'),
    url(r'^(?P<event_id>[^/]+)/(?P<board_id>[^/]+)/invite_judges$',
        comp_views.send_judge_invitations, name='send-all-app-judge-invites'),
    url(r'^(?P<event_id>[^/]+)/dashboard$',
        tv.ManageCompetitionsView.as_view(), name='uni-manage-apps-view'),
    url(r'^(?P<event_id>[^/]+)/judge_progress$',
        tv.ViewJudges.as_view(), name='uni-manage-app-judge-progress'),
    url(r'^(?P<event_id>[^/]+)/judge_progress/(?P<judge_id>[^/]+)$',
        tv.ViewJudgeReview.as_view(), name='uni-manage-app-judge-review'),
    url(r'^(?P<event_id>[^/]+)/archive_judge$',
        comp_views.archive_judge, name='uni-archive-app-judge'),
    url(r'^(?P<event_id>[^/]+)/send_feedback$',
        comp_views.send_feedback_to_applicants, name='uni-send-app-judge-feedback'),
    url(r'^(?P<event_id>[^/]+)/applicants$',
        tv.ViewApps.as_view(), name='uni-manage-applicants'),
    url(r'^(?P<event_id>[^/]+)/applicants/(?P<app_url_name>[^/]+)$',
        tv.ViewApplication.as_view(), name='uni-view-application'),
    url(r'^(?P<event_id>[^/]+)/bulk_message_applicants',
        comp_views.bulk_message_applicants, name='uni-bulk-message-applicants'),
    url(r'^(?P<event_id>[^/]+)/customize_emails$',
        tv.CustomizeCompetitionEmails.as_view(), name='uni-edit-app-emails'),
    url(r'^(?P<event_id>[^/]+)/export/applicants$',
        tv.ExportApplication.as_view(), name='uni-export-all-applications'),
    url(r'^(?P<event_id>[^/]+)/export/applicants/(?P<app_url_name>[^/]+)$',
        tv.ExportApplication.as_view(), name='uni-export-single-application'),
    url(r'^(?P<event_id>[^/]+)/export/applicants/judge/(?P<judge_id>[^/]+)$',
        tv.ExportApplication.as_view(), name='uni-export-all-judge-applications'),
    url(r'^(?P<event_id>[^/]+)/export/applicants/(?P<app_url_name>[^/]+)/attachments$',
        tv.ExportCompAttachments.as_view(), name='uni-export-all-app-attachments'),
    # not used for now
    # url(r'^(?P<event_id>[^/]+)/export/attachments/judge/(?P<judge_id>[^/]+)$',
    #     tv.ExportCompAttachments.as_view(), name='uni-export-all-judge-app-attachments'),
    url(r'^(?P<event_id>[^/]+)/template$',
        tv.GenerateCompFromTemplate.as_view(), name='application-generate-template'),
    url(r'^(?P<event_id>[^/]+)/reorder_questions$',
        tv.ApplicationQuestionReorder.as_view(), name='uni-reorder-app-questions'),
    url(r'^(?P<event_id>[^/]+)/reorder_rubric$',
        tv.ApplicationRubricReorder.as_view(), name='uni-reorder-app-rubric'),
    url(r'^(?P<event_id>[^/]+)/submit_applicant/(?P<app_url_name>[^/]+)$',
        tv.AdminSubmitApplicant.as_view(), name='uni-submit-applicant'),
    url(r'^export/(?P<event_id>[^/]+)$',
        tv.ExportCompetition.as_view(), name='uni-export-application'),
    url(r'^delete',
        tv.DeleteCompetition.as_view(), name='uni-delete-application'),
    url(r'^form/(?P<event_id>[^/]+)$',
        comp_views.show_competition_application, name='application-form'),
    # allow admins to view and edit submitted applications
    url(r'^form/(?P<event_id>[^/]+)/member/(?P<sm_applicant_id>[^/]+)$',
        comp_views.show_competition_application, name='application-form-admin-sm'),
    url(r'^form/(?P<event_id>[^/]+)/guest/(?P<anon_applicant_id>[^/]+)$',
        comp_views.show_competition_application, name='application-form-admin-anon'),
    url(r'^apply/(?P<event_id>[-@\w]+)/member/(?P<sm_applicant_id>[^/]+)$',
        comp_views.competition_apply, name='application-apply-admin-sm'),
    url(r'^apply/(?P<event_id>[-@\w]+)/guest/(?P<anon_applicant_id>[^/]+)$',
        comp_views.competition_apply, name='application-apply-admin-anon'),
]
